#!/bin/sh

# udev external PROGRAM script
# return devfs-names for ide-devices
# KERNEL="[hs]d*", PROGRAM="/etc/udev/idescsi-devfs.sh %k %b %n", NAME="%k", SYMLINK="%c{1}"

HOST="${2%\.[0-9]}"
TARGET="${2#[0-9]\.}"

if [ -z "${HOST#[13579]}" ]; then
	HOST=$((${HOST} - 1))
	BUS="1"
else
	BUS="0"
fi

get_dev_number() {
	num=0
	DRIVE="${1%%[0-9]*}"

	for x in /proc/ide/*/media; do
		if [ -e "${x}" ]; then
			lMEDIA=`cat ${x}`
			if [ "${lMEDIA}" = "$2" ]; then
				num=$((${num} + 1))
			fi
			if [ "${x}" = "/proc/ide/${DRIVE}/media" ]; then
				break
			fi
		fi
	done

	echo $((${num} - 1))
}

get_dev_number_1() {
	result=null
	DRIVE="${1%%[0-9]*}"
	NEXT=0

	for x in /dev/discs/*/disc; do
		aux="${x%/*}"
		num="${aux##*disc}"
		if [ "${num}" = "${NEXT}" ]; then
			NEXT=$((${NEXT} +1))
		fi
		ACTUAL=`ls -l ${x}`      
		if [ -e "${x}" -a "${ACTUAL##*/}" == "${DRIVE}" ]; then
			result="${num}"
			break
		fi
	done 
	
	if [ ${result} == null ]; then
		result=${NEXT}
	fi
	echo "${result}"
}

if [ -z "$3" ] && [ -f /proc/ide/${1}/media ]; then
	MEDIA=`cat /proc/ide/${1}/media`
	if [ "${MEDIA}" = "cdrom" ]; then
		echo cdroms/cdrom`get_dev_number $1 cdrom`
	elif [ "${MEDIA}" = "floppy" ]; then
		echo  floppies/floppy`get_dev_number $1 floppy`/disc
	elif [ "${MEDIA}" = "disk" ] ; then
		echo  discs/disc`get_dev_number_1 $1`/disc
	fi
else
	if [ -z "$3" ]; then
		echo discs/disc`get_dev_number_1 $1`/disc
	else echo discs/disc`get_dev_number_1 $1`/part$3
	fi
fi
